IOSS 2.0

Public Member Functions | Static Public Member Functions | Static Public Attributes | List of all members
Iocgns::Utils Class Reference

`#include <Iocgns_Utils.h>`

## Public Member Functions
| Utils ()=default
| ~Utils ()=default

## Static Public Member Functions
static size_t | index (const Ioss::Field &field)
static void | cgns_error (int cgnsid, const char *file, const char *function, int lineno, int processor)
static void | update_db_zone_property (int cgns_file_ptr, const Ioss::Region *region, int myProcessor, bool is_parallel, bool is_parallel_io)
static int | get_db_zone (const Ioss::EntityBlock *block)
static void | set_field_index (const Ioss::Field &field, size_t index, CG_GridLocation_t location)
static bool | is_cell_field (const Ioss::Field &field)
template<typename INT >
static void | map_cgns_face_to_ioss (const Ioss::ElementTopology *parent_topo, size_t num_to_get, INT *idata)
static void | map_ioss_face_to_cgns (const Ioss::ElementTopology *parent_topo, size_t num_to_get, std::vector< cgsize_t > &data)
static void | write_flow_solution_metadata (int file_ptr, Ioss::Region *region, int state, int *vertex_solution_index, int *cell_center_solution_index, bool is_parallel_io)
static int | find_solution_index (int cgns_file_ptr, int base, int zone, int step, CG_GridLocation_t location)
static Ioss::MeshType | check_mesh_type (int cgns_file_ptr)
static size_t | common_write_meta_data (int file_ptr, const Ioss::Region &region, std::vector< size_t > &zone_offset, bool is_parallel)
static size_t | resolve_nodes (Ioss::Region &region, int my_processor, bool is_parallel)
static std::vector< std::vector< std::pair< size_t, size_t > > > | resolve_processor_shared_nodes (Ioss::Region &region, int my_processor)
static CG_ElementType_t | map_topology_to_cgns (const std::string &name)
static std::string | map_cgns_to_topology_type (CG_ElementType_t type)
static void | add_sidesets (int cgns_file_ptr, Ioss::DatabaseIO *db)
static void | add_structured_boundary_conditions (int cgns_file_ptr, Ioss::StructuredBlock *block, bool is_parallel_io)
static void | add_structured_boundary_conditions_fpp (int cgns_file_ptr, Ioss::StructuredBlock *block)
static void | add_structured_boundary_conditions_pio (int cgns_file_ptr, Ioss::StructuredBlock *block)
static void | finalize_database (int cgns_file_ptr, const std::vector< double > &timesteps, Ioss::Region *region, int myProcessor, bool is_parallel_io)
static int | get_step_times (int cgns_file_ptr, std::vector< double > &timesteps, Ioss::Region *region, double timeScaleFactor, int myProcessor)
static void | add_transient_variables (int cgns_file_ptr, const std::vector< double > &timesteps, Ioss::Region *region, bool enable_field_recognition, char suffix_separator, int myProcessor, bool is_parallel_io)
static void | set_line_decomposition (int cgns_file_ptr, const std::string &line_decomposition, std::vector< Iocgns::StructuredZoneData * > &zones, int rank, bool verbose)
static void | decompose_model (std::vector< Iocgns::StructuredZoneData * > &zones, int proc_count, int rank, double load_balance_threshold, bool verbose)
static size_t | pre_split (std::vector< Iocgns::StructuredZoneData * > &zones, double avg_work, double load_balance, int proc_rank, int proc_count, bool verbose)
static void | assign_zones_to_procs (std::vector< Iocgns::StructuredZoneData * > &zones, std::vector< size_t > &work_vector, bool verbose)
static void | show_config ()

## Static Public Attributes
static const size_t | CG_CELL_CENTER_FIELD_ID = 1ul << 33
static const size_t | CG_VERTEX_FIELD_ID = 1ul << 34

## Constructor & Destructor Documentation

## ◆ Utils()

Iocgns::Utils::Utils | ( |  | ) |
| default

## ◆ ~Utils()

Iocgns::Utils::~Utils | ( |  | ) |
| default

## Member Function Documentation

## ◆ add_sidesets()

void Iocgns::Utils::add_sidesets | ( | int | cgns_file_ptr,
|  | Ioss::DatabaseIO * | db
| ) |  |
| static

## ◆ add_structured_boundary_conditions()

void Iocgns::Utils::add_structured_boundary_conditions | ( | int | cgns_file_ptr,
|  | Ioss::StructuredBlock * | block,
|  | bool | is_parallel_io
| ) |  |
| static

## ◆ add_structured_boundary_conditions_fpp()

void Iocgns::Utils::add_structured_boundary_conditions_fpp | ( | int | cgns_file_ptr,
|  | Ioss::StructuredBlock * | block
| ) |  |
| static

## ◆ add_structured_boundary_conditions_pio()

void Iocgns::Utils::add_structured_boundary_conditions_pio | ( | int | cgns_file_ptr,
|  | Ioss::StructuredBlock * | block
| ) |  |
| static

## ◆ add_transient_variables()

void Iocgns::Utils::add_transient_variables | ( | int | cgns_file_ptr,
|  | const std::vector< double > & | timesteps,
|  | Ioss::Region * | region,
|  | bool | enable_field_recognition,
|  | char | suffix_separator,
|  | int | myProcessor,
|  | bool | is_parallel_io
| ) |  |
| static

## ◆ assign_zones_to_procs()

void Iocgns::Utils::assign_zones_to_procs | ( | std::vector< Iocgns::StructuredZoneData * > & | zones,
|  | std::vector< size_t > & | work_vector,
|  | bool | verbose
| ) |  |
| static

## ◆ cgns_error()

void Iocgns::Utils::cgns_error | ( | int | cgnsid,
|  | const char * | file,
|  | const char * | function,
|  | int | lineno,
|  | int | processor
| ) |  |
| static

## ◆ check_mesh_type()

Ioss::MeshType Iocgns::Utils::check_mesh_type | ( | int | cgns_file_ptr | ) |
| static

## ◆ common_write_meta_data()

size_t Iocgns::Utils::common_write_meta_data | ( | int | file_ptr,
|  | const Ioss::Region & | region,
|  | std::vector< size_t > & | zone_offset,
|  | bool | is_parallel
| ) |  |
| static

## ◆ decompose_model()

void Iocgns::Utils::decompose_model | ( | std::vector< Iocgns::StructuredZoneData * > & | zones,
|  | int | proc_count,
|  | int | rank,
|  | double | load_balance_threshold,
|  | bool | verbose
| ) |  |
| static

## ◆ finalize_database()

void Iocgns::Utils::finalize_database | ( | int | cgns_file_ptr,
|  | const std::vector< double > & | timesteps,
|  | Ioss::Region * | region,
|  | int | myProcessor,
|  | bool | is_parallel_io
| ) |  |
| static

## ◆ find_solution_index()

int Iocgns::Utils::find_solution_index | ( | int | cgns_file_ptr,
|  | int | base,
|  | int | zone,
|  | int | step,
|  | CG_GridLocation_t | location
| ) |  |
| static

## ◆ get_db_zone()

int Iocgns::Utils::get_db_zone | ( | const Ioss::EntityBlock * | block | ) |
| static

## ◆ get_step_times()

int Iocgns::Utils::get_step_times | ( | int | cgns_file_ptr,
|  | std::vector< double > & | timesteps,
|  | Ioss::Region * | region,
|  | double | timeScaleFactor,
|  | int | myProcessor
| ) |  |
| static

## ◆ index()

size_t Iocgns::Utils::index | ( | const Ioss::Field & | field | ) |
| static

## ◆ is_cell_field()

bool Iocgns::Utils::is_cell_field | ( | const Ioss::Field & | field | ) |
| static

## ◆ map_cgns_face_to_ioss()

template<typename INT >

static void Iocgns::Utils::map_cgns_face_to_ioss | ( | const Ioss::ElementTopology * | parent_topo,
|  | size_t | num_to_get,
|  | INT * | idata
| ) |  |
| inline static

## ◆ map_cgns_to_topology_type()

std::string Iocgns::Utils::map_cgns_to_topology_type | ( | CG_ElementType_t | type | ) |
| static

## ◆ map_ioss_face_to_cgns()

static void Iocgns::Utils::map_ioss_face_to_cgns | ( | const Ioss::ElementTopology * | parent_topo,
|  | size_t | num_to_get,
|  | std::vector< cgsize_t > & | data
| ) |  |
| inline static

## ◆ map_topology_to_cgns()

CG_ElementType_t Iocgns::Utils::map_topology_to_cgns | ( | const std::string & | name | ) |
| static

## ◆ pre_split()

size_t Iocgns::Utils::pre_split | ( | std::vector< Iocgns::StructuredZoneData * > & | zones,
|  | double | avg_work,
|  | double | load_balance,
|  | int | proc_rank,
|  | int | proc_count,
|  | bool | verbose
| ) |  |
| static

## ◆ resolve_nodes()

size_t Iocgns::Utils::resolve_nodes | ( | Ioss::Region & | region,
|  | int | my_processor,
|  | bool | is_parallel
| ) |  |
| static

## ◆ resolve_processor_shared_nodes()

std::vector< std::vector< std::pair< size_t, size_t > > > Iocgns::Utils::resolve_processor_shared_nodes | ( | Ioss::Region & | region,
|  | int | my_processor
| ) |  |
| static

## ◆ set_field_index()

void Iocgns::Utils::set_field_index | ( | const Ioss::Field & | field,
|  | size_t | index,
|  | CG_GridLocation_t | location
| ) |  |
| static

## ◆ set_line_decomposition()

void Iocgns::Utils::set_line_decomposition | ( | int | cgns_file_ptr,
|  | const std::string & | line_decomposition,
|  | std::vector< Iocgns::StructuredZoneData * > & | zones,
|  | int | rank,
|  | bool | verbose
| ) |  |
| static

## ◆ show_config()

void Iocgns::Utils::show_config | ( |  | ) |
| static

## ◆ update_db_zone_property()

void Iocgns::Utils::update_db_zone_property | ( | int | cgns_file_ptr,
|  | const Ioss::Region * | region,
|  | int | myProcessor,
|  | bool | is_parallel,
|  | bool | is_parallel_io
| ) |  |
| static

## ◆ write_flow_solution_metadata()

void Iocgns::Utils::write_flow_solution_metadata | ( | int | file_ptr,
|  | Ioss::Region * | region,
|  | int | state,
|  | int * | vertex_solution_index,
|  | int * | cell_center_solution_index,
|  | bool | is_parallel_io
| ) |  |
| static

## Member Data Documentation

## ◆ CG_CELL_CENTER_FIELD_ID

const size_t Iocgns::Utils::CG_CELL_CENTER_FIELD_ID = 1ul << 33
| static

## ◆ CG_VERTEX_FIELD_ID

const size_t Iocgns::Utils::CG_VERTEX_FIELD_ID = 1ul << 34
| static

The documentation for this class was generated from the following files:

- src/cgns/Iocgns_Utils.h
- src/cgns/Iocgns_Utils.C